;
;	xvO
;	  $IAS.SYS̑Oɑgݍ
;	  IWiint 10hoĂB
;
;	1993. 7.16  Ver 0.1  ŏ̃o[W
;
	.model	small

VER	equ	'0.1'

TAB	equ	09h
CR	equ	0dh
LF	equ	0ah

movseg	macro	seg1,seg2
	push	seg2
	pop	seg1
	endm

puts	macro	msg
	mov	dx,offset msg
	mov	ah,09h
	int	21h
	endm

	.code
	assume	cs:@code,ds:@code

	org	0000h
dev_header	dd	-1		;link
		dw	0c000h		;device attr.
		dw	strategy	;
		dw	interrupt	;
		db	'$J3$IAS$'	;

packet_adr	dd	?		;
org10h_vect	dd	?		; int 10h vector

;
;	strategy
;
strategy	proc	far
	mov	word ptr cs:[packet_adr],bx
	mov	word ptr cs:[packet_adr+2],es
	ret
strategy	endp

;
;	interrupt
;
interrupt	proc	far
	push	es ax bx

	les	bx,cs:[packet_adr]

	mov	word ptr es:[bx+3],8103h	; error stat

	mov	al,es:[bx+2]
	or	al,al			; init ?
	jnz	inter_10

	call	init_dev

	jmp	short inter_ok
inter_10:
	cmp	al,03h
	jnz	inter_ret

	push	es bx

	cmp	word ptr es:[bx+18],4		; size check
	jnz	inter_ret

	les	bx,dword ptr es:[bx+14]		; es:bx .. address

	mov	ax,word ptr cs:[org10h_vect]
	mov	word ptr es:[bx],ax
	mov	ax,word ptr cs:[org10h_vect+2]
	mov	word ptr es:[bx+2],ax

	pop	bx es
inter_ok:
	mov	word ptr es:[bx+3],0100h	;
inter_ret:
	pop	bx ax es
	ret
interrupt	endp

end_dev		equ	$

;
;	initial (device driver)
;
init_dev	proc	near
	push	dx

	puts	title_msg

	push	es bx

	mov	ax,3510h			; get int10h vector
	int	21h				; out es:bx
	mov	word ptr ds:[org10h_vect],bx
	mov	word ptr ds:[org10h_vect+2],es

	pop	bx es

	puts	install_msg

	mov	ax,cs:[dev_size]
	mov	word ptr es:[bx+14],ax
	mov	word ptr es:[bx+16],cs

	mov	word ptr es:[bx+3],0100h	;

	pop	dx
	ret
init_dev	endp

dev_size	dw	end_dev

title_msg	db	'uvxvO  $IASΉ  Ver ',VER
		db	'  By Takapyu'
cr_lf		db	0dh,0ah,'$'
install_msg	db	'  Installed.',0dh,0ah,'$'

	end
